<?xml version="1.0"?>
<xsl:stylesheet version="1.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="html" indent="yes"/>

    <!-- Root. -->
    <xsl:template match="/">
        <HTML>
        <HEAD>
        <TITLE><xsl:value-of select="name(/*)"/></TITLE>
        </HEAD>
        <BODY>

        <!-- Process the data root node. -->
        <xsl:apply-templates/>

        </BODY>
        </HTML>
    </xsl:template>

    <!-- The data root node. -->
    <xsl:template match="/*">
        <!-- Start the table. -->
        <TABLE BORDER="1" CELLPADDING="2">

        <!-- Make column headers. -->
        <THEAD>
            <xsl:for-each select="*[1]/attribute::*">
                <TH><xsl:value-of select="name()"/></TH>
            </xsl:for-each>
        </THEAD>

        <!-- Process the data record nodes. -->
        <xsl:apply-templates/>

        <!-- Close the table. -->
        </TABLE>
    </xsl:template>

    <!-- Data record nodes. -->
    <xsl:template match="/*/*">
        <TR>
            <!-- Display the attributes. -->
            <xsl:for-each select="attribute::*">
                <TD>
                    <xsl:value-of select="."/>
                </TD>
            </xsl:for-each>
        </TR>
    </xsl:template>

</xsl:stylesheet>
